﻿using System;

namespace Dynamicweb.Ecommerce.LiveIntegration.EndpointMonitoring
{
    /// <summary>
    /// Represents endpoint status
    /// </summary>
    internal class EndpointStatus
    {
        /// <summary>
        /// Error status
        /// </summary>
        public bool Error { get; set; }

        /// <summary>
        /// Last ERP communication time
        /// </summary>
        public DateTime? LastErpCommunication { get; set; }

        /// <summary>
        /// Checks if the status is stil valid
        /// </summary>
        /// <returns>True if status is still valid otherwise false</returns>
        public bool IsStillValid()
        {
            return !Error && LastErpCommunication.HasValue && DateTime.Now.Subtract(LastErpCommunication.Value).Minutes < 5;
        }

        /// <summary>
        /// Sets endpoint communication to success.
        /// </summary>
        public void SetSuccess()
        {
            Error = false;
            LastErpCommunication = DateTime.Now;
        }

        /// <summary>
        /// Sets endpoint communication failed.
        /// </summary>
        public void SetError()
        {
            Error = true;
            LastErpCommunication = DateTime.Now;
        }
    }
}
